﻿using System;
using System.Windows.Browser;
using ReactiveUI;

namespace ResharperBugRepro
{
	public class TestViewModel : ReactiveObject
	{
		public TestViewModel()
		{
			uriObservable = this.WhenAny(x => x.IntProperty, x => x.StringProperty, (i, s) => GetUri()).ToProperty(this, x => x.Uri);
		}

		public int IntProperty { get; set; }
		public string StringProperty { get; set; }

		private readonly ObservableAsPropertyHelper<Uri> uriObservable;
		public Uri Uri
		{
			get { return uriObservable.Value; }
		}
		private Uri GetUri()
		{
			var builder = new UriBuilder(HtmlPage.Document.DocumentUri);
			builder.Path = @"/" + StringProperty + @"/" + IntProperty;
			builder.Fragment = string.Empty;
			return builder.Uri;
		}
	}
}
